/*
 * Copyright 2020 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * Prism: Lightweight, robust, elegant syntax highlighting
 * MIT license http://www.opensource.org/licenses/mit-license.php/
 * @author Lea Verou http://lea.verou.me
 */(function(){var e=/\blang(?:uage)?-(?!\*)(\w+)\b/i,t=self.Prism={util:{type:function(e){return Object.prototype.toString.call(e).match(/\[object (\w+)\]/)[1]},clone:function(e){var n=t.util.type(e);switch(n){case"Object":var r={};for(var i in e)e.hasOwnProperty(i)&&(r[i]=t.util.clone(e[i]));return r;case"Array":return e.slice()}return e}},languages:{extend:function(e,n){var r=t.util.clone(t.languages[e]);for(var i in n)r[i]=n[i];return r},insertBefore:function(e,n,r,i){i=i||t.languages;var s=i[e],o={};for(var u in s)if(s.hasOwnProperty(u)){if(u==n)for(var a in r)r.hasOwnProperty(a)&&(o[a]=r[a]);o[u]=s[u]}return i[e]=o},DFS:function(e,n){for(var r in e){n.call(e,r,e[r]);t.util.type(e)==="Object"&&t.languages.DFS(e[r],n)}}},highlightAll:function(e,n){var r=document.querySelectorAll('code[class*="language-"], [class*="language-"] code, code[class*="lang-"], [class*="lang-"] code');for(var i=0,s;s=r[i++];)t.highlightElement(s,e===!0,n)},highlightElement:function(r,i,s){var o,u,a=r;while(a&&!e.test(a.className))a=a.parentNode;if(a){o=(a.className.match(e)||[,""])[1];u=t.languages[o]}if(!u)return;r.className=r.className.replace(e,"").replace(/\s+/g," ")+" language-"+o;a=r.parentNode;/pre/i.test(a.nodeName)&&(a.className=a.className.replace(e,"").replace(/\s+/g," ")+" language-"+o);var f=r.textContent;if(!f)return;f=f.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/\u00a0/g," ");var l={element:r,language:o,grammar:u,code:f};t.hooks.run("before-highlight",l);if(i&&self.Worker){var c=new Worker(t.filename);c.onmessage=function(e){l.highlightedCode=n.stringify(JSON.parse(e.data),o);l.element.innerHTML=l.highlightedCode;s&&s.call(l.element);t.hooks.run("after-highlight",l)};c.postMessage(JSON.stringify({language:l.language,code:l.code}))}else{l.highlightedCode=t.highlight(l.code,l.grammar,l.language);l.element.innerHTML=l.highlightedCode;s&&s.call(r);t.hooks.run("after-highlight",l)}},highlight:function(e,r,i){return n.stringify(t.tokenize(e,r),i)},tokenize:function(e,n,r){var i=t.Token,s=[e],o=n.rest;if(o){for(var u in o)n[u]=o[u];delete n.rest}e:for(var u in n){if(!n.hasOwnProperty(u)||!n[u])continue;var a=n[u],f=a.inside,l=!!a.lookbehind||0;a=a.pattern||a;for(var c=0;c<s.length;c++){var h=s[c];if(s.length>e.length)break e;if(h instanceof i)continue;a.lastIndex=0;var p=a.exec(h);if(p){l&&(l=p[1].length);var d=p.index-1+l,p=p[0].slice(l),v=p.length,m=d+v,g=h.slice(0,d+1),y=h.slice(m+1),b=[c,1];g&&b.push(g);var w=new i(u,f?t.tokenize(p,f):p);b.push(w);y&&b.push(y);Array.prototype.splice.apply(s,b)}}}return s},hooks:{all:{},add:function(e,n){var r=t.hooks.all;r[e]=r[e]||[];r[e].push(n)},run:function(e,n){var r=t.hooks.all[e];if(!r||!r.length)return;for(var i=0,s;s=r[i++];)s(n)}}},n=t.Token=function(e,t){this.type=e;this.content=t};n.stringify=function(e,r,i){if(typeof e=="string")return e;if(Object.prototype.toString.call(e)=="[object Array]")return e.map(function(t){return n.stringify(t,r,e)}).join("");var s={type:e.type,content:n.stringify(e.content,r,i),tag:"span",classes:["token",e.type],attributes:{},language:r,parent:i};s.type=="comment"&&(s.attributes.spellcheck="true");t.hooks.run("wrap",s);var o="";for(var u in s.attributes)o+=u+'="'+(s.attributes[u]||"")+'"';return"<"+s.tag+' class="'+s.classes.join(" ")+'" '+o+">"+s.content+"</"+s.tag+">"};if(!self.document){self.addEventListener("message",function(e){var n=JSON.parse(e.data),r=n.language,i=n.code;self.postMessage(JSON.stringify(t.tokenize(i,t.languages[r])));self.close()},!1);return}var r=document.getElementsByTagName("script");r=r[r.length-1];if(r){t.filename=r.src;document.addEventListener&&!r.hasAttribute("data-manual")&&document.addEventListener("DOMContentLoaded",t.highlightAll)}})();;
Prism.languages.clike={comment:{pattern:/(^|[^\\])(\/\*[\w\W]*?\*\/|[^:]\/\/.*?(\r?\n|$))/g,lookbehind:!0},string:/("|')(\\?.)*?\1/g,keyword:/\b(if|else|while|do|for|return|in|instanceof|function|new|try|catch|finally|null|break|continue)\b/g,"boolean":/\b(true|false)\b/g,number:/\b-?(0x)?\d*\.?[\da-f]+\b/g,operator:/[-+]{1,2}|!|=?&lt;|=?&gt;|={1,2}|(&amp;){1,2}|\|?\||\?|\*|\//g,ignore:/&(lt|gt|amp);/gi,punctuation:/[{}[\];(),.:]/g};;
Prism.languages.java=Prism.languages.extend("clike",{keyword:/\b(abstract|continue|for|new|switch|assert|default|goto|package|synchronized|boolean|do|if|private|this|break|double|implements|protected|throw|byte|else|import|public|throws|case|enum|instanceof|return|transient|catch|extends|int|short|try|char|final|interface|static|void|class|finally|long|strictfp|volatile|const|float|native|super|while)\b/g,number:/\b0b[01]+\b|\b0x[\da-f]*\.?[\da-fp\-]+\b|\b\d*\.?\d+[e]?[\d]*[df]\b|\W\d*\.?\d+\b/gi,operator:{pattern:/([^\.]|^)([-+]{1,2}|!|=?&lt;|=?&gt;|={1,2}|(&amp;){1,2}|\|?\||\?|\*|\/|%|\^|(&lt;){2}|($gt;){2,3}|:|~)/g,lookbehind:!0}});;
Prism.languages.groovy = Prism.languages.extend('clike', {
  'keyword': /\b(as|def|in|abstract|assert|boolean|break|byte|case|catch|char|class|const|continue|default|do|double|else|enum|extends|final|finally|float|for|goto|if|implements|import|instanceof|int|interface|long|native|new|package|private|protected|public|return|short|static|strictfp|super|switch|synchronized|this|throw|throws|transient|try|void|volatile|while)\b/g,
  'string': /("""|''')[\W\w]*?\1|("|'|\/)[\W\w]*?\2/g,
  'number': /\b0b[01_]+\b|\b0x[\da-f_]+(\.[\da-f_p\-]+)?\b|\b[\d_]+(\.[\d_]+[e]?[\d]*)?[glidf]\b|[\d_]+(\.[\d_]+)?\b/gi,
  'operator': /={0,2}~|\?\.|\*?\.@|\.&amp;|\.(?=\w)|\.{2}(&lt;)?(?=\w)|-&gt;|\?:|[-+]{1,2}|!|&lt;=&gt;|(&gt;){1,3}|(&lt;){1,2}|={1,2}|(&amp;){1,2}|\|{1,2}|\?|\*{1,2}|\/|\^|%/g,
  'punctuation': /\.+|[{}[\];(),:$]/g,
  'annotation': /@\w+/
});

Prism.languages.insertBefore('groovy', 'punctuation', {
  'spock-block': /\b(setup|given|when|then|and|cleanup|expect|where):/g
});

Prism.hooks.add('wrap', function(env) {
  if (env.language === 'groovy' && env.type === 'string') {
    var delimiter = env.content[0];

    if (delimiter != "'") {
      env.content = Prism.highlight(env.content, {
        'expression': {
          pattern: /([^\\])(\$(\{.*?\}|[\w\.]*))/,
          lookbehind: true,
          inside: Prism.languages.groovy
        }
      });

      env.classes.push(delimiter === '/' ? 'regex' : 'gstring');
    }
  }
});
'use strict';(function(b){var d=0;b.rpkUniqueId=function(a){return(a?a:"ui-")+ ++d}})(jQuery);
(function(b){b.rpkToggleImports=function(d){var a=b.extend({lang:"java",action:"hide",actionEl:null},d);d=["hide","show"];if(-1!=b.inArray(a.lang,["java","groovy"])&&-1!=b.inArray(a.action,d)){if(a.actionEl)if("show"===a.action){var g=b(a.actionEl).parent("code.language-"+a.lang);b(a.actionEl).remove();a.actionEl=null}else"hide"===a.action&&(g=b(a.actionEl).parent("code.language-"+a.lang));else g=b("code.language-"+a.lang);g.each(function(d){var k=!0;b(this).children("span.token.keyword").filter(function(){return"import"===
b(this).text()}).each(function(d,e){var c=b(e);if("hide"===a.action&&k){var g=b.rpkUniqueId("showImports-");c.hasClass("gutter-open")&&c.removeClass("gutter-open");c.before('\x3cspan class\x3d"token keyword gutter-folded" id\x3d"'+g+'"\x3eimport ...\n\n\x3c/span\x3e');b("#"+g).css("cursor","pointer").click(function(){b.rpkToggleImports({lang:a.lang,action:"show",actionEl:"#"+g})});k=!1}else"show"===a.action&&k&&(c.hasClass("gutter-open")||c.addClass("gutter-open"),k=!1);d=[e];var l=c.siblings().length;
for(c=e;0<=l;){e=c.nextElementSibling;if("hide"===a.action&&c.nextSibling&&3===c.nextSibling.nodeType){var f=c.nextSibling.textContent;f&&(c.nextSibling.textContent="",b(c).after("\x3cspan\x3e"+f+"\x3c/span\x3e"),d[d.length]=c.nextElementSibling)}if(!e)break;d[d.length]=e;f=(c=e.nextSibling)&&3===c.nodeType&&c.textContent;if("java"===a.lang&&";"===b(e).text()||"groovy"===a.lang&&0<=b(e).text().indexOf("\n")||"groovy"===a.lang&&f){if("hide"===a.action&&f&&0<=c.textContent.indexOf("\n")){f=c.textContent;
var h=f.indexOf("\n");for(++h;h<f.length&&"\n"===f[h];h++);l=f.substring(0,h);f=f.substring(h);c.textContent=f?f:"";b(e).after("\x3cspan\x3e"+l+"\x3c/span\x3e");d[d.length]=e.nextElementSibling;break}if("show"===a.action&&e.nextElementSibling){(c=b(e.nextElementSibling).text())&&0<=c.indexOf("\n")&&(d[d.length]=e.nextElementSibling);break}}if(0<=b(e).text().indexOf("\n"))break;c=e;l--}b.each(d,function(d,c){"hide"===a.action?b(c).hide():"show"===a.action&&b(c).show().css("cursor","pointer").off("click").click(function(){var c=
this.id||b.rpkUniqueId("showImports-");this.id||(this.id=c);b.rpkToggleImports({lang:a.lang,action:"hide",actionEl:"#"+c})})})})})}}})(jQuery);
(function(b){b.rpkHighlightJavadocCode=function(){b("pre").each(function(d){d=b(this);var a=d.attr("class");!a||-1==a.indexOf("tested")&&-1==a.indexOf("groovy-chain-dsl")&&-1==a.indexOf("groovy-ratpack-dsl")&&-1==a.indexOf("java-chain-dsl")&&-1==a.indexOf("java")&&-1==a.indexOf("exec")&&-1==a.indexOf("not-tested")||(d.attr("class",a+" language-groovy"),a=d.html(),d.html('\x3ccode class\x3d"language-groovy"\x3e'+a.replace(/^ /gm,"").replace(/\s+$/g,"")+"\x3c/code\x3e"),d.children("code.language-groovy").each(function(){Prism.highlightElement(this,
!1,null)}))})}})(jQuery);$(function(){$.rpkHighlightJavadocCode();$.rpkToggleImports({lang:"java",action:"hide"});$.rpkToggleImports({lang:"groovy",action:"hide"})});
